class
	P_EFFECT_STEREOREVERSE_STATIC

inherit
	CE_UTILITIES
	S_SDL_SDL_ERROR_STATIC

feature {ANY} -- public routines

	eff_reversestereo16 (a_chan: INTEGER_32; a_stream: CE_POINTER [ANY]; a_len: INTEGER_32; a_udata: CE_POINTER [ANY])
		local
			l_ptr: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
		do
			l_ptr := create {CE_NATURAL_32_POINTER}.make_cast (a_stream)
			l_i := 0
			from
			until
				not (l_i < a_len)
			loop
				l_ptr.item := (((((l_ptr.item).bit_and ({NATURAL_32} 4_294_901_760))).bit_shift_right (16))).bit_or (((((l_ptr.item).bit_and ({NATURAL_32} 65_535))).bit_shift_left (16)))
				l_i := (l_i.to_natural_32 + {PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32
				l_ptr := l_ptr + 1
			end
		end

	eff_reversestereo8 (a_chan: INTEGER_32; a_stream: CE_POINTER [ANY]; a_len: INTEGER_32; a_udata: CE_POINTER [ANY])
		local
			l_len: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			l_p: CE_POINTER [NATURAL_16]
		do
			l_len := a_len
			l_ptr := create {CE_NATURAL_32_POINTER}.make_cast (a_stream)
			if l_len.to_natural_32 \\ {PLATFORM}.Natural_32_bytes.to_natural_32 /= {NATURAL_32} 0 then
				l_p := create {CE_NATURAL_16_POINTER}.make_cast ((create {CE_NATURAL_8_POINTER}.make_cast (a_stream) + (l_len - 2)))
				l_p.item := (((((((l_p.item).to_integer_32).bit_and (65_280))).bit_shift_right (8)).to_natural_32).bit_or (((((l_ptr.item).bit_and ({NATURAL_32} 255))).bit_shift_left (8)))).to_natural_16
				l_len := l_len - (2)
			end
			l_i := 0
			from
			until
				not (l_i < l_len)
			loop
				l_ptr.item := (((((((((l_ptr.item).bit_and ({NATURAL_32} 65_280))).bit_shift_right (8))).bit_or (((((l_ptr.item).bit_and ({NATURAL_32} 255))).bit_shift_left (8))))).bit_or (((((l_ptr.item).bit_and ({NATURAL_32} 4_278_190_080))).bit_shift_right (8))))).bit_or (((((l_ptr.item).bit_and ({NATURAL_32} 16_711_680))).bit_shift_left (8)))
				l_i := (l_i.to_natural_32 + {PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32
				l_ptr := l_ptr + 1
			end
		end

	mix_set_reverse_stereo (a_channel, a_flip: INTEGER_32): INTEGER_32
		local
			l_f: CE_ROUTINE
			l_channels: CE_ARRAY [INTEGER_32]
			l_format: CE_ARRAY [NATURAL_16]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_channels.make (<<1>>)
			create {CE_NATURAL_16_ARRAY} l_format.make (<<1>>)

			l_f := create {CE_ROUTINE}.make_shared (default_pointer);
			(create {P_MIXER_STATIC}).mix_query_spec (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_format, l_channels).do_nothing
			if l_channels.item = 2 then
				if (((l_format.item).to_integer_32).bit_and (255)) = 16 then
					l_f := eff_reversestereo16_address
				elseif (((l_format.item).to_integer_32).bit_and (255)) = 8 then
					l_f := eff_reversestereo8_address
				else
					sdl_set_error ([ce_string ("Unsupported audio format")])
					Result := 0
					l_return := True
				end
				if not l_return then
					if not a_flip.to_boolean then
						Result := ((create {P_MIXER_STATIC}).mix_unregister_effect (a_channel, l_f))
						l_return := True
					else
						Result := ((create {P_MIXER_STATIC}).mix_register_effect2 (a_channel, l_f, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer)))
						l_return := True
					end
				end
			end
			if not l_return then
				Result := 1
			end
		end

feature {ANY} -- routine addresses

	eff_reversestereo16_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_reversestereo16)
		end

	eff_reversestereo8_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent eff_reversestereo8)
		end

end
