class
	S_STDIO_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	vsnprintf (a_dest: CE_POINTER [INTEGER_8]; a_count: NATURAL_32; a_format: CE_POINTER [INTEGER_8]; a_args: CE_VA_LIST): INTEGER_32
		do
			Result := c_vsnprintf (a_dest.c_pointer, a_count, a_format.c_pointer, a_args.c_pointer)
		end

	c_vsnprintf (a_dest: POINTER; a_count: NATURAL_32; a_format: POINTER; a_args: POINTER): INTEGER_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return _vsnprintf($a_dest, $a_count, $a_format, $a_args);"
		end

	vsnprintf2 (a_s: CE_POINTER [INTEGER_8]; a_n: NATURAL_32; a_format: CE_POINTER [INTEGER_8]; a_arg: CE_VA_LIST): INTEGER_32
		local
			l_arg: CE_VA_LIST
		do
			l_arg := a_arg.twin
			Result := (vsnprintf (a_s, a_n, a_format, l_arg.twin))
		end

	vsnwprintf (a_dest: CE_POINTER [NATURAL_16]; a_count: NATURAL_32; a_format: CE_POINTER [NATURAL_16]; a_args: CE_VA_LIST): INTEGER_32
		do
			Result := c_vsnwprintf (a_dest.c_pointer, a_count, a_format.c_pointer, a_args.c_pointer)
		end

	c_vsnwprintf (a_dest: POINTER; a_count: NATURAL_32; a_format: POINTER; a_args: POINTER): INTEGER_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return _vsnwprintf($a_dest, $a_count, $a_format, $a_args);"
		end

	vsnwprintf2 (a_s: CE_POINTER [NATURAL_16]; a_n: NATURAL_32; a_format: CE_POINTER [NATURAL_16]; a_arg: CE_VA_LIST): INTEGER_32
		local
			l_arg: CE_VA_LIST
		do
			l_arg := a_arg.twin
			Result := (vsnwprintf (a_s, a_n, a_format, l_arg.twin))
		end

end
